Task 1: Adding Two Numbers
The objective of this task was to implement a simple program in Assembly that:

Declared two integers in memory.
Used the add instruction to sum them.
Displayed the result using a provided print_int function.
This task provided an introduction to:

Defining and accessing global variables in Assembly.
Using basic arithmetic operations like add and mov.
Calling external functions from Assembly (e.g., print_int) and managing the stack.
Task 2: Loops and Conditionals
This task involved translating C constructs like loops and conditionals into Assembly. Specific challenges included:

Implementing a loop to sum an array of integers.
Adding logic to validate user input and conditionally execute code.
Key learning outcomes:

How to implement loops in Assembly using labels and jump instructions (jmp, je).
Translating array accesses into memory offset calculations.
Using conditional instructions (cmp, je, jg, etc.) to branch code execution based on comparisons.
Additional Tasks:
Prompting the user for input and validating the range.
Computing the sum of an array over a user-defined range.
Task 3: Makefile
This task introduced the use of a Makefile to manage the compilation and linking of multiple Assembly and C programs. The key objectives were to:

Create rules to build object files (.o) for both Assembly and C programs.
Define dependencies to ensure only changed files were rebuilt.
Automate the cleanup of intermediate files with a clean rule.
The use of a Makefile greatly simplified the workflow, ensuring faster builds and avoiding manual compilation of individual files.

Key concepts covered:

Understanding targets, prerequisites, and recipes in Makefiles.
Using pattern rules (%.o) to handle repetitive tasks.
Leveraging make for multi-target builds and efficient project management.
